export function $classOf(arg: any): any;
export function $isString(arg: any): arg is string;
export function $isNumber(arg: any): arg is number;
export function $isObject(arg: any): arg is Record<string, any>;
export const $isArray: (arg: any) => arg is any[];
export function $in(key: any, ref: any): boolean;
export function $get(ref: any, ...keys: string[]): any;
export function $eq(x: any, y: any): boolean;
export const $: {
    <T extends $Tag>(config: $TConfig<T>, namespace?: string): T extends keyof HTMLElementTagNameMap ? HTMLElementTagNameMap[T] : T extends keyof SVGElementTagNameMap ? SVGElementTagNameMap[T] : Element;
    <E extends $Element>(config: $EConfig<E>, namespace?: string): E;
};
export const $ti: <T extends $Tag>(t: T, ...i: $Item[]) => T extends keyof HTMLElementTagNameMap ? HTMLElementTagNameMap[T] : T extends keyof SVGElementTagNameMap ? SVGElementTagNameMap[T] : Element;
export const $tai: <T extends $Tag>(t: T, a: $Attributes, ...i: $Item[]) => T extends keyof HTMLElementTagNameMap ? HTMLElementTagNameMap[T] : T extends keyof SVGElementTagNameMap ? SVGElementTagNameMap[T] : Element;
export const $tpi: <T extends $Tag>(t: T, p: $Properties, ...i: $Item[]) => T extends keyof HTMLElementTagNameMap ? HTMLElementTagNameMap[T] : T extends keyof SVGElementTagNameMap ? SVGElementTagNameMap[T] : Element;
export const $tapi: <T extends $Tag>(t: T, a: $Attributes, p: $Properties, ...i: $Item[]) => T extends keyof HTMLElementTagNameMap ? HTMLElementTagNameMap[T] : T extends keyof SVGElementTagNameMap ? SVGElementTagNameMap[T] : Element;
export const $ei: <E extends $Element>(e: E, ...i: $Item[]) => E;
export const $eai: <E extends $Element>(e: E, a: $Attributes, ...i: $Item[]) => E;
export const $epi: <E extends $Element>(e: E, p: $Properties, ...i: $Item[]) => E;
export const $eapi: <E extends $Element>(e: E, a: $Attributes, p: $Properties, ...i: $Item[]) => E;
export function $a(href: string, ...i: $Item[]): HTMLElement;
export function $css(style: $CSS, splitter?: string): string;
export function $highlight(pattern: RegExp, highlighters: ((chunk: string, index: number) => $Item)[], innerText: string): $Item[];
export const $highlightJs: (innerText?: string | undefined) => $Item[];
export function $locale(locales: Record<string, Record<string, string | Record<string, string>>>, defaultLanguage: string, languages?: readonly string[]): (text?: string | undefined, version?: string | undefined) => string;
export type $Attributes = Record<string, string | number | boolean>;
export type $Properties = Record<string, any>;
export type $Item = Node | string | number | $Config;
export type $Tag = keyof HTMLElementTagNameMap | keyof SVGElementTagNameMap;
export type $Element = HTMLElement | SVGElement;
export type $Config = {
    t: $Tag;
    a?: $Attributes;
    p?: $Properties;
    i?: $Item[];
} | {
    e: $Element;
    a?: $Attributes;
    p?: $Properties;
    i?: $Item[];
};
export type $TConfig<T extends $Tag> = {
    t: T;
} & $Config;
export type $EConfig<E extends $Element> = {
    e: E;
} & $Config;
export type $CSSRules = {
    [attributeOrSelector: string]: string | number | $CSSRules;
};
export type $CSS = {
    [selector: string]: $CSSRules;
};
